import { aws_codebuild as cbuild } from 'aws-cdk-lib';
/**
 * Determines the "RunOrder" property for the next action to be added to a stage.
 * @param index Index of new action
 * @param concurrency The concurrency limit
 */
export declare function determineRunOrder(index: number, concurrency?: number): number | undefined;
/**
 * Hashes the contents of a file or directory. If the argument is a directory,
 * it is assumed not to contain symlinks that would result in a cyclic tree.
 *
 * @param fileOrDir the path to the file or directory that should be hashed.
 *
 * @returns a SHA256 hash, base-64 encoded.
 */
export declare function hashFileOrDirectory(fileOrDir: string): string;
export declare function renderEnvironmentVariables(env?: {
    [key: string]: string | undefined;
}, type?: cbuild.BuildEnvironmentVariableType): {
    [key: string]: cbuild.BuildEnvironmentVariable;
} | undefined;
export declare function noUndefined<T>(xs: Partial<T>): {
    [k in keyof T]: T[k];
};
export declare function mapValues<T, U>(xs: {
    [key: string]: T;
}, fn: (x: T) => U): {
    [key: string]: U;
};
export declare function flatMap<T, U>(xs: T[], fn: (x: T) => U[]): U[];
